Synopsis:
---------

These are the sources of a prototype relational analyzer for the
simply-typed λ-calculus with recursion. It infers stable relations
between the inputs and the outputs of a program, based on the
independent attribute abstraction, as described in the ICFP'20 paper
[Stable Relations and Abstract Interpretation of Higher-Order
Programs](https://doi.org/10.1145/3409001).

Build requirements:
-------------------

- OCaml
- dune
- menhir
- cmdliner
- inferno
- ppx_deriving
- js_of_ocaml
- js_of_ocaml-ppx
- js_of_ocaml-tyxml

Build instructions:
-------------------

Type the command ``make``. It will build the executable and the web
demo. You can try the web demo by visiting the file
``src/simpl/demo/stable-rels.html``: the code of the analyzer will run
locally inside your browser.

To run the program:
-------------------

Type the command ``dune exec -- coral-simpl`` followed by the file you
want to analyze, and possible flags. Documentation is available by
running the command ``dune exec -- coral-simpl --help``.

To run tests:
-------------

Type the command ``make test``.
